PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PXML_HTTP Class Reference

`#include <pxml.h>`

Inheritance diagram for PXML_HTTP:
[legend]
Collaboration diagram for PXML_HTTP:
[legend]

## Public Member Functions
| PXML_HTTP (Options options=NoOptions, const char *noIndentElements=NULL)
bool | StartAutoReloadURL (const PURL &url, const PTimeInterval &timeout, const PTimeInterval &refreshTime, Options options=NoOptions)
bool | StopAutoReloadURL ()
PString | GetAutoReloadStatus ()
bool | AutoLoadURL ()
virtual void | OnAutoLoad (PBoolean ok)
bool | LoadURL (const PURL &url)
bool | LoadURL (const PURL &url, const PTimeInterval &timeout, Options options=NoOptions)
bool | LoadURL (const PURL &url, const PURL::LoadParams &params, Options options=NoOptions)
Public Member Functions inherited from PXML
| PXML (Options options=NoOptions, const char *noIndentElements=NULL)
| PXML (const PXML &xml)
| ~PXML ()
bool | IsLoaded () const
bool | IsDirty () const
bool | Load (const PString &data, Options options=NoOptions)
bool | LoadFile (const PFilePath &fn, Options options=NoOptions)
virtual void | OnLoaded ()
bool | Save (Options options=NoOptions)
PString | AsString (Options options=NoOptions)
bool | SaveFile (const PFilePath &fn, Options options=NoOptions)
void | RemoveAll ()
PBoolean | IsNoIndentElement (const PString &elementName) const
PString | AsString () const
void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
PXMLElement * | GetElement (const PCaselessString &name, const PCaselessString &attr, const PString &attrval) const
PXMLElement * | GetElement (const PCaselessString &name, PINDEX idx=0) const
PXMLElement * | GetElement (PINDEX idx) const
PINDEX | GetNumElements () const
PXMLElement * | GetRootElement () const
PXMLElement * | SetRootElement (PXMLElement *p)
PXMLElement * | SetRootElement (const PString &documentType)
bool | RemoveElement (PINDEX idx)
PCaselessString | GetDocumentType () const
bool | Validate (const ValidationInfo *validator)
bool | ValidateElements (ValidationContext &context, PXMLElement *baseElement, const ValidationInfo *elements)
bool | ValidateElement (ValidationContext &context, PXMLElement *element, const ValidationInfo *elements)
bool | LoadAndValidate (const PString &body, const PXML::ValidationInfo *validator, PString &error, Options options=NoOptions)
PString | GetErrorString () const
unsigned | GetErrorColumn () const
unsigned | GetErrorLine () const
PString | GetDocType () const
void | SetDocType (const PString &v)
PMutex & | GetMutex ()
Public Member Functions inherited from PXMLBase
| P_DECLARE_BITWISE_ENUM_EX (Options, 6,(NoOptions, Indent, NewLineAfterElement, NoIgnoreWhiteSpace, CloseExtended, WithNS, FragmentOnly), AllOptions=(1<<(6+1))-1)
| PXMLBase (Options opts=NoOptions)
void | SetOptions (Options opts)
Options | GetOptions () const
void | SetMaxEntityLength (unsigned len)
unsigned | GetMaxEntityLength () const
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...

## Protected Member Functions
| PDECLARE_NOTIFIER (PTimer, PXML_HTTP, AutoReloadTimeout)
| PDECLARE_NOTIFIER (PThread, PXML_HTTP, AutoReloadThread)

## Protected Attributes
PTimer | autoLoadTimer
PURL | autoloadURL
PTimeInterval | autoLoadWaitTime
PMutex | autoLoadMutex
PString | autoLoadError
Protected Attributes inherited from PXML
PXMLElement * | rootElement
PMutex | rootMutex
bool | loadFromFile
PFilePath | loadFilename
PString | version
PString | encoding
StandAloneType | m_standAlone
PStringStream | m_errorString
unsigned | m_errorLine
unsigned | m_errorColumn
PSortedStringList | noIndentElements
PString | docType
PString | m_defaultNameSpace
Protected Attributes inherited from PXMLBase
Options | m_options
unsigned | m_maxEntityLength
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Public Types inherited from PXML
enum | ValidationOp { EndOfValidationList, DocType, ElementName, RequiredAttribute, RequiredNonEmptyAttribute, RequiredAttributeWithValue, RequiredElement, Subtree, RequiredAttributeWithValueMatching, RequiredElementWithBodyMatching, OptionalElement, OptionalAttribute, OptionalNonEmptyAttribute, OptionalAttributeWithValue, OptionalAttributeWithValueMatching, OptionalElementWithBodyMatching, SetDefaultNamespace, SetNamespace, RequiredAttributeWithValueMatchingEx = RequiredAttributeWithValueMatching + 0x8000, OptionalAttributeWithValueMatchingEx = OptionalAttributeWithValueMatching + 0x8000, RequiredElementWithBodyMatchingEx = RequiredElementWithBodyMatching + 0x8000, OptionalElementWithBodyMatchingEx = OptionalElementWithBodyMatching + 0x8000 }
Static Public Member Functions inherited from PXML
static PString | CreateStartTag (const PString &text)
static PString | CreateEndTag (const PString &text)
static PString | CreateTagNoData (const PString &text)
static PString | CreateTag (const PString &text, const PString &data)
static PString | EscapeSpecialChars (const PString &string)
Friends inherited from PObject

## Constructor & Destructor Documentation

PXML_HTTP::PXML_HTTP | ( | Options | options = `NoOptions`,
|  | const char * | noIndentElements = `NULL`
| ) |  |

## Member Function Documentation

bool PXML_HTTP::AutoLoadURL | ( |  | ) |

PString PXML_HTTP::GetAutoReloadStatus | ( |  | ) |
| inline

References autoLoadError, and autoLoadMutex.

bool PXML_HTTP::LoadURL | ( | const PURL & | url | ) |

bool PXML_HTTP::LoadURL | ( | const PURL & | url,
|  | const PTimeInterval & | timeout,
|  | Options | options = `NoOptions`
| ) |  |

bool PXML_HTTP::LoadURL | ( | const PURL & | url,
|  | const PURL::LoadParams & | params,
|  | Options | options = `NoOptions`
| ) |  |

virtual void PXML_HTTP::OnAutoLoad | ( | PBoolean | ok | ) |
| virtual

PXML_HTTP::PDECLARE_NOTIFIER | ( | PTimer | ,
|  | PXML_HTTP | ,
|  | AutoReloadTimeout |
| ) |  |
| protected

PXML_HTTP::PDECLARE_NOTIFIER | ( | PThread | ,
|  | PXML_HTTP | ,
|  | AutoReloadThread |
| ) |  |
| protected

bool PXML_HTTP::StartAutoReloadURL | ( | const PURL & | url,
|  | const PTimeInterval & | timeout,
|  | const PTimeInterval & | refreshTime,
|  | Options | options = `NoOptions`
| ) |  |

bool PXML_HTTP::StopAutoReloadURL | ( |  | ) |

## Member Data Documentation

PString PXML_HTTP::autoLoadError
| protected

Referenced by GetAutoReloadStatus().

PMutex PXML_HTTP::autoLoadMutex
| protected

Referenced by GetAutoReloadStatus().

PTimer PXML_HTTP::autoLoadTimer
| protected

PURL PXML_HTTP::autoloadURL
| protected

PTimeInterval PXML_HTTP::autoLoadWaitTime
| protected

The documentation for this class was generated from the following file:

- pxml.h